macroScript DBAKE category:"Max Override" tooltip:"Bake the transform(s) and rotation(s) of selected object(s) to dummie(s)."  buttontext:"Bk2dum"  Icon:#("MaxOverride",8)
(

dummies_array=#()
canceled="no"
errors="no"

--MASTER CONDITION CHECK : SEE AN OBJECT IS SELECTED--
if selection.count>0 then (
--Function to align dummies to destination object
function align first_object second_object= (
	try ( first_object.rotation = second_object.rotation
	first_object.position = second_object.position  
	/* NOTIFICATION*/ notification = "done with " + second_object.name + " on " + slidertime as string + "."+" *press Esc to cancel* " 
	/* NOTIFICATION*/ pushPrompt notification ) 
	catch(
		errors ="yes" 
		/* NOTIFICATION*/ pushPrompt ">> bake to dummies can't be used on this type of object.<<"
		)
	)
--creates dummies for object(s) and put them to an array
for i=1 to selection.count do (
	dummy_name = "dummy_"+ selection[i].name
	dummy_node = dummy name:dummy_name
	append dummies_array dummy_node 
)

free i

with animate on (
	--loops the baking process n times (the number of frames to bake.)
	for  n=animationrange.start to animationrange.end  do (
		
		/*###### LOOP EXIT CONDITIONS#####*/
		---==sees if there are any conditions to exit the loop==--
		if canceled =="yes" then (
		/* NOTIFICATION*/ pushPrompt "task canceled!"
		exit
			) else if errors =="yes" then (exit) 
		/*###########################*/
		
		slidertime=n
		for i=1 to selection.count  do (
		--SEE IF USER PRESSED ESCAPE KEY AND IF YES, SETS THE 'CANCELED' STRING TO 'YES'	
		if keyboard.escPressed do (canceled="yes")
		align dummies_array[i] selection[i]
		)
	)
if canceled !="yes"  and errors !="yes"  then (/* NOTIFICATION*/ pushPrompt "task ended.")	
)
)
--IF MASTER CONDITION IS NOT MET, WHICH MEANS NO OBJECT IS SELECTED, THEN PROMPTS THAT TO USER.
else (/* NOTIFICATION*/ pushPrompt ">> no objects selected.bake to a dummy can't continue. <<")
)