macroScript VLabel category:"Max Override" tooltip:"Enable/Disable Filename label on viewports"  buttontext:"Vlabel"  Icon:#("MaxOverride",7)
(
	--unregister allthe callbacks
	try (unregisterRedrawViewsCallback viewport_fname) catch (print "No RedrawViewsCallback to remove.")
	callbacks.removeScripts #viewportChange id:#ViewSwtcd
	callbacks.removeScripts #filePostOpen id:#newfileopen
	
--//////////////////DICLARATION OF VARIABLES
global	write_on_vp
global 	viewport_switch_trigger
global 	before_av= viewport.activeViewport	
global 	current_filename=maxFileName
global	vprt_lbl 
--/////////////////DICLARATION OF FUNCTIONS
--FUNCTION : Viewport refresher

fn remove_callbacks= (
	callbacks.removeScripts #viewportChange id:#ViewSwtcd
	callbacks.removeScripts #filePostOpen id:#newfileopen
	)

fn new_file = (
	unregisterRedrawViewsCallback viewport_fname
	remove_callbacks()
	print"-----x0001"
	vprt_lbl = "inactive"
	)

fn viewport_switch_trigger= (
--get the current active viewport id
curent_av=viewport.activeViewport
	--see if the viewport has changed, using comparision between before viewport id and now veiwport id
	if before_av != curent_av then (
		--if viewports have changed, refresh the view, by unregistering and re-registering the redraw views callback
		unregisterRedrawViewsCallback viewport_fname
		registerRedrawViewsCallback  viewport_fname
		--sets the current viewport id as the before viewport id
		before_av=viewport.activeViewport
	)	
)

--FUNCTION: Write on Viewport
function	write_on_vp	stuff_to_write		textcolor	h_pos	v_pos =	(
	gw.htext [v_pos,h_pos,0] stuff_to_write color:textcolor
	gw.updateScreen() 
	)

--FILENAME ON VIEWPORT FUNCTION
function viewport_fname =	(
	--see if file is saved. if yes, displays its name. if not, displays a message saying its not saved.
	if maxFileName!="" then ( write_on_vp current_filename [000,225,000]	5 10) 
	else ( write_on_vp "Current file is not saved!" [225,000,000]	5 10)
)
--/////////////////////////////END OF FUNCTIONS

-- add file open cllback
callbacks.addScript #filePostOpen "new_file()" id:#newfileopen

if vprt_lbl == "inactive" or vprt_lbl == undefined then 
	(
		registerRedrawViewsCallback  viewport_fname
		vprt_lbl = "active"
		callbacks.addScript #viewportChange "viewport_switch_trigger()" id:#ViewSwtcd
		print "Viewport filename label is Visible"
	)

	else 
	(
		unregisterRedrawViewsCallback viewport_fname
		vprt_lbl = "inactive"
		remove_callbacks()
		print "Viewport filename label is Hidden"
	)
)
